#include "AskDialog.h"

//(*InternalHeaders(AskDialog)
#include <wx/font.h>
#include <wx/intl.h>
#include <wx/string.h>
//*)

//(*IdInit(AskDialog)
const long AskDialog::ID_TEXTCTRL1 = wxNewId();
const long AskDialog::ID_OK = wxNewId();
const long AskDialog::ID_CANCEL = wxNewId();
//*)

BEGIN_EVENT_TABLE(AskDialog,wxDialog)
	//(*EventTable(AskDialog)
	//*)
END_EVENT_TABLE()

AskDialog::AskDialog(wxWindow* parent,wxString message)
{
	//(*Initialize(AskDialog)
	wxFlexGridSizer* FlexGridSizer1;

	Create(parent, wxID_ANY, wxEmptyString, wxDefaultPosition, wxDefaultSize, wxSTAY_ON_TOP|wxDEFAULT_DIALOG_STYLE, _T("wxID_ANY"));
	FlexGridSizer1 = new wxFlexGridSizer(0, 2, 0, 0);
	mss_ctrl = new wxTextCtrl(this, ID_TEXTCTRL1, _("Text"), wxDefaultPosition, wxSize(277,113), wxTE_MULTILINE|wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL1"));
	wxFont mss_ctrlFont(8,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
	mss_ctrl->SetFont(mss_ctrlFont);
	FlexGridSizer1->Add(mss_ctrl, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	Button1 = new wxButton(this, ID_OK, _("Ok"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_OK"));
	Button1->SetDefault();
	wxFont Button1Font(11,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
	Button1->SetFont(Button1Font);
	FlexGridSizer1->Add(Button1, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	FlexGridSizer1->Add(-1,-1,1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	cancel = new wxButton(this, ID_CANCEL, _("No"), wxDefaultPosition, wxDefaultSize, 0, wxDefaultValidator, _T("ID_CANCEL"));
	wxFont cancelFont(11,wxFONTFAMILY_SWISS,wxFONTSTYLE_NORMAL,wxFONTWEIGHT_NORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
	cancel->SetFont(cancelFont);
	FlexGridSizer1->Add(cancel, 1, wxALL|wxALIGN_CENTER_HORIZONTAL|wxALIGN_CENTER_VERTICAL, 5);
	SetSizer(FlexGridSizer1);
	FlexGridSizer1->Fit(this);
	FlexGridSizer1->SetSizeHints(this);

	Connect(ID_OK,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&AskDialog::OnOk);
	Connect(ID_CANCEL,wxEVT_COMMAND_BUTTON_CLICKED,(wxObjectEventFunction)&AskDialog::OnNo);
	//*)
	mss_ctrl->SetValue(message);
}

AskDialog::~AskDialog()
{
	//(*Destroy(AskDialog)
	//*)
}


void AskDialog::OnOk(wxCommandEvent& event)
{
    EndModal(1);
}

void AskDialog::OnNo(wxCommandEvent& event)
{
   EndModal(0);
}
