/*
 *   Copyright (C) 2011-2017, Michael Anders, FH-Wedel
 *
 *  This file is part of the ECC-Implementation "Academic Signature"
 *  Maintainer: Michael Anders
 *
 *  All rights reserved.
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License along
 *  with this program; if not, write to the Free Software Foundation, Inc.,
 *  51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */
 

#ifndef PW_REQUEST_H
#define PW_REQUEST_H

//(*Headers(pw_request)
#include <wx/button.h>
#include <wx/dialog.h>
#include <wx/sizer.h>
#include <wx/stattext.h>
#include <wx/textctrl.h>
#include <wx/timer.h>
//*)

class pw_request: public wxDialog
{
	public:

		pw_request(wxWindow* parent,wxString msg, wxString *pw, wxWindowID id=wxID_ANY,const wxPoint& pos=wxDefaultPosition,const wxSize& size=wxDefaultSize);
		virtual ~pw_request();

		//(*Declarations(pw_request)
		wxButton* Button1;
		wxStaticText* StaticText1;
		wxTextCtrl* comm_ctrl;
		wxTextCtrl* pw_ctrl;
		wxTimer Timer1;
		//*)

	protected:

		//(*Identifiers(pw_request)
		static const long ID_STATICTEXT1;
		static const long ID_TEXTCTRL1;
		static const long ID_TEXTCTRL2;
		static const long ID_BUTTON1;
		static const long ID_TIMER1;
		//*)

	private:

		//(*Handlers(pw_request)
		void OnTimer1Trigger(wxTimerEvent& event);
		void OnSubmit(wxCommandEvent& event);
		//*)

		int half_min_counter;
		wxString *ppw;

		DECLARE_EVENT_TABLE()
};

#endif
